* PACKAGE LEIGEN  !" $BNO3X(B $B8GM-CM2r@O(B
*
*"  [HIS] 92/12/14(takepiro) $B!V9TNs7W;;%=%U%H%&%'%"!W;HMQ(B
*"        92/12/18(takepiro)  Numerical Recipies $B;HMQ(B
*"        93/05/10(takepiro)  $B%(%i!<=hCVJQ99(B
*"        93/06/11(takepiro)  $B8GM-4X?t7W;;%9%$%C%AF3F~(B
*"        95/06/13(takepiro)  $B8GM-%Y%/%H%k7W;;?tF3F~(B
*
**********************************************************************
      SUBROUTINE LEIGEN
     M            ( AMAT   , 
     O              EIGVLR , EIGVLI ,
     O              EIGVCR , EIGVCI ,
     O              IERR   , 
     I              MATDIM , OEIVEC , NVEC  )
*
      IMPLICIT NONE
*
#include        "zcdim.F"                    !" 
#include        "zldim.F"                    !" $B78?t9TNs$NBg$-$5(B
*
*   [MODIFY] 
      REAL      AMAT  ( MATDMX, MATDMX )     !" $B78?t9TNs(B
*
*   [OUTPUT] 
      REAL      EIGVLR( MATDMX )             !" $B8GM-CM<B?tIt(B
      REAL      EIGVLI( MATDMX )             !" $B8GM-CM5u?tIt(B
      REAL      EIGVCR( MATDMX, * )          !" $B8GM-%Y%/%H%k<B?tIt(B
      REAL      EIGVCI( MATDMX, * )          !" $B8GM-%Y%/%H%k5u?tIt(B
      INTEGER   IERR                         !" $B%5%V%k!<%A%s%(%i!<%3!<%I(B
*
*   [INPUT] 
      INTEGER   MATDIM                       !" $B7W;;$9$k<!85(B
      LOGICAL   OEIVEC                       !" $B8GM-4X?t7W;;%9%$%C%A(B
      INTEGER   NVEC                         !" $B8GM-4X?t7W;;?t(B
*
*   [INTERNAL WORK] 
      COMMON    /COMWRK/  Z
*
      REAL      SCALE ( MATDMX )             !" $B%9%1!<%j%s%0>pJs(B
      INTEGER   LOW, IGH                     !" 
      REAL      INT   ( MATDMX )             !" $B%X%C%;%s%Y%k%0JQ49>pJs(B
      REAL      Z     ( MATDMX, MATDMX )     !" $B8GM-%Y%/%H%k(B
*
      CHARACTER HERR*8                       !" $B%(%i!<HV9f=PNOMQJ8;zJQ?t(B
      INTEGER   NERR                         !" $BJ8;zNs$ND9$5(B
      INTEGER   LENC                         !" $BJ8;z$ND9$5$rJV$94X?t(B
*
      SAVE      
*
*"  < 1. $B%P%i%s%7%s%0(B >
*
      CALL BALANC
     I      (  MATDMX , MATDIM , 
     M         AMAT   ,
     O         LOW    , IGH    ,SCALE  )
*
*"  < 2. $B%X%C%;%s%Y%k%09TNsJQ49(B >
*
      CALL ELMHES
     I      (  MATDMX , MATDIM , 
     I         LOW    , IGH    , 
     M         AMAT   , INT      )
*
      CALL ELTRAN
     I      (  MATDMX , MATDIM , 
     I         LOW    , IGH    , 
     I         AMAT   , INT    , 
     O         Z                 )

*
*"  < 3. $B8GM-CM$N7W;;(B >
*
      CALL HQR2
     I      (  MATDMX , MATDIM , 
     I         LOW    , IGH    , 
     I         AMAT   , 
     O         EIGVLR , EIGVLI , 
     M         Z      , 
     O         IERR              )
*
      IF ( IERR .NE. 0 ) THEN
         WRITE( HERR , '(I5)' ) IERR
         CALL CLADJ( HERR )
         NERR = LENC( HERR )
         CALL MSGDMP( 'W', 'LEIGEN', 
     &         'IERR = '//HERR(1:NERR)//' : EIGENVALUES NOT CORRECT ' )
      ENDIF
*
*"  < 4. $B8GM-%Y%/%H%k$N7W;;(B >
*
      IF ( OEIVEC ) THEN
         CALL BALBAK
     I      (  MATDMX , MATDIM , 
     I         LOW    , IGH    , 
     I         SCALE  , MATDIM , 
     M         Z                  )
      ENDIF
*
*"  < 5. $B8GM-%Y%/%H%k$NJB$SBX$((B > 
*
      CALL EIGSRT
     M      (  EIGVLR , EIGVLI , 
     O         EIGVCR , EIGVCI ,
     I         Z      , 
     I         MATDIM , OEIVEC , NVEC  )
*
*"  < 5. $B=*N;(B > 
*
      RETURN
      END
************************************************************************
      SUBROUTINE EIGSRT      !" $B8GM-CM8GM-%Y%/%H%kJB$YJQ$((B
     M      (  EIGVLR , EIGVLI , 
     O         EIGVCR , EIGVCI , 
     I         Z      , 
     I         MATDIM , OEIVEC , NVEC  )
*
      IMPLICIT NONE
*
*   [PARA]
#include        "zcdim.F"                    !" 
#include        "zldim.F"                    !" $B78?t9TNs$NBg$-$5(B
*
*   [OUTPUT] 
      REAL      EIGVLR( MATDMX )             !" $B8GM-CM<B?tIt(B
      REAL      EIGVLI( MATDMX )             !" $B8GM-CM5u?tIt(B
      REAL      EIGVCR( MATDMX, * )          !" $B8GM-%Y%/%H%k<B?tIt(B
      REAL      EIGVCI( MATDMX, * )          !" $B8GM-%Y%/%H%k5u?tIt(B
*
*   [INPUT]
      REAL      Z     ( MATDMX, MATDMX )     !" $B8GM-%Y%/%H%k(B
*
      INTEGER   MATDIM                       !" $B7W;;$9$k<!85(B
      LOGICAL   OEIVEC                       !" $B8GM-4X?t7W;;%9%$%C%A(B
      INTEGER   NVEC                         !" $B8GM-4X?t7W;;?t(B
*
*   [INTERNAL WORK]
      INTEGER   J, K
      INTEGER   INDX  ( MATDMX )             !" $B=gHV3JG<G[Ns(B
      REAL      WORK  ( MATDMX )             !" $B8GM-CMF~$l49$(MQG[Ns(B
*
*
*"  < 1. $B8GM-CM$N%=!<%H(B >
*
      CALL INDEXX                                   !" $B8GM-CM<B?tIt$N>.$5$$=g(B
     I       ( MATDIM , EIGVLR ,
     O         INDX              )
*
      CALL COPY( WORK, EIGVLR, MATDIM )             !" $B8GM-CM<B?tIt(B
      DO 1100 J = 1, MATDIM                         !" $B8GM-CM<B?tIt$NBg$-$$=g(B
         EIGVLR( J ) = WORK( INDX( MATDIM-J+1 )  )
 1100 CONTINUE
*
      CALL COPY( WORK, EIGVLI, MATDIM )             !" $B8GM-CM5u?tIt(B
      DO 1200 J = 1, MATDIM                         !" $B8GM-CM<B?tIt$NBg$-$$=g(B
         EIGVLI( J ) = WORK( INDX( MATDIM-J+1 ) )
 1200 CONTINUE
*
*"  < 2. $B8GM-%Y%/%H%k$NF~$l49$((B, $B%=!<%H(B >
*
      IF ( OEIVEC )THEN                 
         DO 2000 K = 1, NVEC                        !" $B8GM-CM<B?tIt$NBg$-$$=g(B
            IF ( EIGVLI(K) .EQ. 0.0 ) THEN
               DO 2100 J = 1, MATDIM
                  EIGVCR( J,K ) = Z( J,INDX(MATDIM-K+1)  )
                  EIGVCI( J,K ) = 0.
 2100          CONTINUE
*
            ELSE IF ( EIGVLI(K) .GE. 0.0 ) THEN
               DO 2200 J = 1, MATDIM
                  EIGVCR( J,K ) =  Z( J,INDX(MATDIM-K+1) ) 
                  EIGVCI( J,K ) =  Z( J,INDX(MATDIM-K+1)+1 )
 2200          CONTINUE
*
            ELSE
               DO 2300 J = 1, MATDIM
                  EIGVCR(J,K) =    Z( J,INDX(MATDIM-K+1)-1 )
                  EIGVCI(J,K) =  - Z( J,INDX(MATDIM-K+1) )
 2300          CONTINUE
            ENDIF
 2000    CONTINUE 
      ENDIF
*
      RETURN
      END
